"""

Image-sequence pair fixtures for image encoder tests.

Contents:
- image - 128x32 binary image
- seq - image encoder sequence as produced by Cozmo
- alt_seq - optional image encoder sequence as produced by PyCozmo and works with Cozmo

"""

FIXTURES = {
    "blank": {
        "image": """
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
""",
        "seq": "3f:3f",
    },
    "fill_screen": {
        "image": """
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
""",
        "seq": "fe:7f:7e",
    },
    "fill_screen2": {
        "image": """
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
................................................................................................................................
""",
        "seq": "fa:7f:7e",
        "alt_seq": "f9:7f:7e",
    },
    "top_left": {
        "image": """
1...............................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
""",
        "seq": "82:3f:3e",
        "alt_seq": "81:3f:3e",
    },
    "top_left_5": {
        "image": """
....1...........................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
""",
        "seq": "03:82:3f:3a",
        "alt_seq": "03:81:3f:3a",
    },
    "top_left_1_8": {
        "image": """
1.......1.......................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
""",
        "seq": "82:06:82:3f:36",
        "alt_seq": "81:06:81:3f:36",
    },
    "top_left_line": {
        "image": """
11111111........................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
""",
        "seq": "82:46:3f:37",
        "alt_seq": "81:46:3f:37",
    },
    "top_line": {
        "image": """
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
""",
        "seq": "82:7f:7e",
        "alt_seq": "81:7f:7e",
    },
    "bottom_line": {
        "image": """
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
""",
        "seq": "f8:82:7f:7e",
    },
    "left_line": {
        "image": """
1...............................................................................................................................
1...............................................................................................................................
1...............................................................................................................................
1...............................................................................................................................
1...............................................................................................................................
1...............................................................................................................................
1...............................................................................................................................
1...............................................................................................................................
1...............................................................................................................................
1...............................................................................................................................
1...............................................................................................................................
1...............................................................................................................................
1...............................................................................................................................
1...............................................................................................................................
1...............................................................................................................................
1...............................................................................................................................
1...............................................................................................................................
1...............................................................................................................................
1...............................................................................................................................
1...............................................................................................................................
1...............................................................................................................................
1...............................................................................................................................
1...............................................................................................................................
1...............................................................................................................................
1...............................................................................................................................
1...............................................................................................................................
1...............................................................................................................................
1...............................................................................................................................
1...............................................................................................................................
1...............................................................................................................................
1...............................................................................................................................
1...............................................................................................................................
""",
        "seq": "fe:3f:3e",
    },
    "right_line": {
        "image": """
...............................................................................................................................1
...............................................................................................................................1
...............................................................................................................................1
...............................................................................................................................1
...............................................................................................................................1
...............................................................................................................................1
...............................................................................................................................1
...............................................................................................................................1
...............................................................................................................................1
...............................................................................................................................1
...............................................................................................................................1
...............................................................................................................................1
...............................................................................................................................1
...............................................................................................................................1
...............................................................................................................................1
...............................................................................................................................1
...............................................................................................................................1
...............................................................................................................................1
...............................................................................................................................1
...............................................................................................................................1
...............................................................................................................................1
...............................................................................................................................1
...............................................................................................................................1
...............................................................................................................................1
...............................................................................................................................1
...............................................................................................................................1
...............................................................................................................................1
...............................................................................................................................1
...............................................................................................................................1
...............................................................................................................................1
...............................................................................................................................1
...............................................................................................................................1
""",
        "seq": "3f:3e:fe",
    },
    "columns": {
        "image": """
1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.
1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.
1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.
1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.
1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.
1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.
1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.
1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.
1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.
1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.
1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.
1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.
1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.
1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.
1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.
1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.
1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.
1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.
1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.
1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.
1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.
1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.
1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.
1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.
1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.
1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.
1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.
1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.
1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.
1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.
1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.
1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.1.
""",
        "seq": "fe:00:fe:00:fe:00:fe:00:fe:00:fe:00:fe:00:fe:00:"
               "fe:00:fe:00:fe:00:fe:00:fe:00:fe:00:fe:00:fe:00:"
               "fe:00:fe:00:fe:00:fe:00:fe:00:fe:00:fe:00:fe:00:"
               "fe:00:fe:00:fe:00:fe:00:fe:00:fe:00:fe:00:fe:00:"
               "fe:00:fe:00:fe:00:fe:00:fe:00:fe:00:fe:00:fe:00:"
               "fe:00:fe:00:fe:00:fe:00:fe:00:fe:00:fe:00:fe:00:"
               "fe:00:fe:00:fe:00:fe:00:fe:00:fe:00:fe:00:fe:00:"
               "fe:00:fe:00:fe:00:fe:00:fe:00:fe:00:fe:00:fe:00",
    },
    "rect": {
        "image": """
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
1..............................................................................................................................1
1..............................................................................................................................1
1..............................................................................................................................1
1..............................................................................................................................1
1..............................................................................................................................1
1..............................................................................................................................1
1..............................................................................................................................1
1..............................................................................................................................1
1..............................................................................................................................1
1..............................................................................................................................1
1..............................................................................................................................1
1..............................................................................................................................1
1..............................................................................................................................1
1..............................................................................................................................1
1..............................................................................................................................1
1..............................................................................................................................1
1..............................................................................................................................1
1..............................................................................................................................1
1..............................................................................................................................1
1..............................................................................................................................1
1..............................................................................................................................1
1..............................................................................................................................1
1..............................................................................................................................1
1..............................................................................................................................1
1..............................................................................................................................1
1..............................................................................................................................1
1..............................................................................................................................1
1..............................................................................................................................1
1..............................................................................................................................1
1..............................................................................................................................1
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
""",
        "seq": "fe:82:f4:82:7f:7c:fe",
        "alt_seq": "fe:81:f4:82:7f:7c:fe",
    },
    "rect2": {
        "image": """
.111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111.
""",
        "seq": "00:fe:82:f4:82:7f:7a:fe:00",
        "alt_seq": "00:fe:81:f4:82:7f:7a:fe:00",
    },
    "rect3": {
        "image": """
................................................................................................................................
.111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.1............................................................................................................................1.
.111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111.
................................................................................................................................
""",
        "seq": "00:80:f6:80:80:82:ec:82:7f:7a:80:f6:00",
        "alt_seq": "00:80:f5:80:80:81:ec:81:7f:7a:80:f5:00",
    },
    "rect4": {
        "image": """
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
1.1111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111.1
1.1..........................................................................................................................1.1
1.1..........................................................................................................................1.1
1.1..........................................................................................................................1.1
1.1..........................................................................................................................1.1
1.1..........................................................................................................................1.1
1.1..........................................................................................................................1.1
1.1..........................................................................................................................1.1
1.1..........................................................................................................................1.1
1.1..........................................................................................................................1.1
1.1..........................................................................................................................1.1
1.1..........................................................................................................................1.1
1.1..........................................................................................................................1.1
1.1..........................................................................................................................1.1
1.1..........................................................................................................................1.1
1.1..........................................................................................................................1.1
1.1..........................................................................................................................1.1
1.1..........................................................................................................................1.1
1.1..........................................................................................................................1.1
1.1..........................................................................................................................1.1
1.1..........................................................................................................................1.1
1.1..........................................................................................................................1.1
1.1..........................................................................................................................1.1
1.1..........................................................................................................................1.1
1.1..........................................................................................................................1.1
1.1..........................................................................................................................1.1
1.1..........................................................................................................................1.1
1.1..........................................................................................................................1.1
1.1..........................................................................................................................1.1
1.1111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111.1
11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
""",
        "seq": "fe:82:f4:82:fe:86:ec:86:7f:78:fe:82:f4:82:fe",
        "alt_seq": "fe:81:f4:82:fe:85:ec:86:7f:78:fe:81:f4:82:fe",
    },
    "diagonal": {
        "image": """
1111............................................................................................................................
....1111........................................................................................................................
........1111....................................................................................................................
............1111................................................................................................................
................1111............................................................................................................
....................1111........................................................................................................
........................1111....................................................................................................
............................1111................................................................................................
................................1111............................................................................................
....................................1111........................................................................................
........................................1111....................................................................................
............................................1111................................................................................
................................................1111............................................................................
....................................................1111........................................................................
........................................................1111....................................................................
............................................................1111................................................................
................................................................1111............................................................
....................................................................1111........................................................
........................................................................1111....................................................
............................................................................1111................................................
................................................................................1111............................................
....................................................................................1111........................................
........................................................................................1111....................................
............................................................................................1111................................
................................................................................................1111............................
....................................................................................................1111........................
........................................................................................................1111....................
............................................................................................................1111................
................................................................................................................1111............
....................................................................................................................1111........
........................................................................................................................1111....
............................................................................................................................1111
""",
        "seq": "81:42:80:81:42:84:81:42:88:81:42:8c:81:42:90:81:"
               "42:94:81:42:98:81:42:9c:81:42:a0:81:42:a4:81:42:"
               "a8:81:42:ac:81:42:b0:81:42:b4:81:42:b8:81:42:bc:"
               "81:42:c0:81:42:c4:81:42:c8:81:42:cc:81:42:d0:81:"
               "42:d4:81:42:d8:81:42:dc:81:42:e0:81:42:e4:81:42:"
               "e8:81:42:ec:81:42:f0:81:42:f4:81:42:f8:81:42",
        "alt_seq": "81:42:80:81:42:84:81:42:88:81:42:8c:81:42:90:81:"
                   "42:94:81:42:98:81:42:9c:81:42:a0:81:42:a4:81:42:"
                   "a8:81:42:ac:81:42:b0:81:42:b4:81:42:b8:81:42:bc:"
                   "81:42:c0:81:42:c4:81:42:c8:81:42:cc:81:42:d0:81:"
                   "42:d4:81:42:d8:81:42:dc:81:42:e0:81:42:e4:81:42:"
                   "e8:81:42:ec:81:42:f0:81:42:f4:81:42:f8:82:42"
    },
    "diagonal2": {
        "image": """
............................................................................................................................1111
........................................................................................................................1111....
....................................................................................................................1111........
................................................................................................................1111............
............................................................................................................1111................
........................................................................................................1111....................
....................................................................................................1111........................
................................................................................................1111............................
............................................................................................1111................................
........................................................................................1111....................................
....................................................................................1111........................................
................................................................................1111............................................
............................................................................1111................................................
........................................................................1111....................................................
....................................................................1111........................................................
................................................................1111............................................................
............................................................1111................................................................
........................................................1111....................................................................
....................................................1111........................................................................
................................................1111............................................................................
............................................1111................................................................................
........................................1111....................................................................................
....................................1111........................................................................................
................................1111............................................................................................
............................1111................................................................................................
........................1111....................................................................................................
....................1111........................................................................................................
................1111............................................................................................................
............1111................................................................................................................
........1111....................................................................................................................
....1111........................................................................................................................
1111............................................................................................................................
""",
        "seq": "f8:81:42:f4:81:42:f0:81:42:ec:81:42:e8:81:42:e4:"
               "81:42:e0:81:42:dc:81:42:d8:81:42:d4:81:42:d0:81:"
               "42:cc:81:42:c8:81:42:c4:81:42:c0:81:42:bc:81:42:"
               "b8:81:42:b4:81:42:b0:81:42:ac:81:42:a8:81:42:a4:"
               "81:42:a0:81:42:9c:81:42:98:81:42:94:81:42:90:81:"
               "42:8c:81:42:88:81:42:84:81:42:80:81:42:81:42",
        "alt_seq": "f8:82:42:f4:81:42:f0:81:42:ec:81:42:e8:81:42:e4:"
                   "81:42:e0:81:42:dc:81:42:d8:81:42:d4:81:42:d0:81:"
                   "42:cc:81:42:c8:81:42:c4:81:42:c0:81:42:bc:81:42:"
                   "b8:81:42:b4:81:42:b0:81:42:ac:81:42:a8:81:42:a4:"
                   "81:42:a0:81:42:9c:81:42:98:81:42:94:81:42:90:81:"
                   "42:8c:81:42:88:81:42:84:81:42:80:81:42:81:42"
    },
    "blocks": {
        "image": """
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
.....1111.....1111.....1111.....1111.....1111.....1111.....1111.....1111.....1111.....1111.....1111.....1111.....1111.....1111..
.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1..
.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1..
.....1111.....1111.....1111.....1111.....1111.....1111.....1111.....1111.....1111.....1111.....1111.....1111.....1111.....1111..
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
.....1111.....1111.....1111.....1111.....1111.....1111.....1111.....1111.....1111.....1111.....1111.....1111.....1111.....1111..
.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1..
.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1..
.....1111.....1111.....1111.....1111.....1111.....1111.....1111.....1111.....1111.....1111.....1111.....1111.....1111.....1111..
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
.....1111.....1111.....1111.....1111.....1111.....1111.....1111.....1111.....1111.....1111.....1111.....1111.....1111.....1111..
.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1..
.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1.....1..1..
.....1111.....1111.....1111.....1111.....1111.....1111.....1111.....1111.....1111.....1111.....1111.....1111.....1111.....1111..
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
""",
        "seq": "04:90:8d:90:8d:90:8d:90:90:81:84:81:90:81:84:81:90:81:84:81:40:90:8d:90:8d:90:8d:04:90:8d:90:8d:"
               "90:8d:90:90:81:84:81:90:81:84:81:90:81:84:81:40:90:8d:90:8d:90:8d:04:90:8d:90:8d:90:8d:90:90:81:"
               "84:81:90:81:84:81:90:81:84:81:40:90:8d:90:8d:90:8d:04:90:8d:90:8d:90:8d:90:90:81:84:81:90:81:84:"
               "81:90:81:84:81:40:90:8d:90:8d:90:8d:04:90:8d:90:8d:90:8d:90:90:81:84:81:90:81:84:81:90:81:84:81:"
               "40:90:8d:90:8d:90:8d:04:90:8d:90:8d:90:8d:90:90:81:84:81:90:81:84:81:90:81:84:81:40:90:8d:90:8d:"
               "90:8d:04:90:8d:90:8d:90:8d:90:90:81:84:81:90:81:84:81:90:81:84:81:40:90:8d:90:8d:90:8d:04:90:8d:"
               "90:8d:90:8d:90:90:81:84:81:90:81:84:81:90:81:84:81:40:90:8d:90:8d:90:8d:04:90:8d:90:8d:90:8d:90:"
               "90:81:84:81:90:81:84:81:90:81:84:81:40:90:8d:90:8d:90:8d:04:90:8d:90:8d:90:8d:90:90:81:84:81:90:"
               "81:84:81:90:81:84:81:40:90:8d:90:8d:90:8d:04:90:8d:90:8d:90:8d:90:90:81:84:81:90:81:84:81:90:81:"
               "84:81:40:90:8d:90:8d:90:8d:04:90:8d:90:8d:90:8d:90:90:81:84:81:90:81:84:81:90:81:84:81:40:90:8d:"
               "90:8d:90:8d:04:90:8d:90:8d:90:8d:90:90:81:84:81:90:81:84:81:90:81:84:81:40:90:8d:90:8d:90:8d:04:"
               "90:8d:90:8d:90:8d:90:90:81:84:81:90:81:84:81:90:81:84:81:40:90:8d:90:8d:90:8d:01",
    },
    "pycozmo": {
        "image": """
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
.......111111111111......................11111111111............................................................................
.......11111111111111..................1111111111111............................................................................
.......1111.....11111111111....11111..111111.......1.....1111111111....11111111111...1111111111111111111......1111111111........
.......11111....11111..11111..11111...11111.............111111111111...11111111111...11111111111111111111....111111111111.......
.......1111111111111....1111..11111...1111.............11111....11111......111111....11111...11111...1111...11111....11111......
.......11111111111......1111111111....11111............1111......1111....111111......1111....1111....1111...1111......1111......
.......1111..............11111111......111111.....11...11111....11111...111111.......1111....1111....1111...11111....11111......
.......1111...............111111........111111111111....111111111111...11111111111...1111....1111....1111....111111111111.......
.......1111...............111111...........1111111.........111111......11111111111...1111....1111....1111.......111111..........
........................1111111.................................................................................................
........................111111..................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
""",
        "seq": "06:a8:a1:42:a8:85:80:89:b8:a8:85:84:85:42:a8:95:40:a8:91:bc:ac:8d:bc:ac:89:c0:b0:81:40:b0:85:c0:"
               "b0:8d:88:85:a4:b0:91:84:85:a4:b0:a1:a4:b4:9d:a4:bc:95:40:b4:99:a8:b0:99:ac:b0:91:b4:b0:8d:b8:b0:"
               "89:bc:b0:81:01:b0:8d:b8:ac:95:b4:ac:99:b0:a8:9d:b0:a8:8d:80:89:b0:a8:89:88:89:ac:a8:85:8c:89:ac:"
               "a8:85:90:85:43:a8:85:8c:85:b0:a8:89:88:85:02:b8:89:b4:b4:91:b0:b0:95:40:b0:89:80:89:ac:b0:85:88:"
               "85:42:b0:89:80:89:ac:b0:95:40:b4:91:b0:b8:89:01:b0:85:88:85:ac:b0:85:84:89:ac:b0:85:80:8d:40:b0:"
               "99:41:b0:8d:80:85:ac:b0:89:84:85:40:b0:85:88:85:02:b0:99:42:b0:89:bc:b0:85:41:b0:99:42:b0:89:bc:"
               "b0:85:41:b0:99:41:b4:95:02:b8:89:b4:b4:91:b0:b0:95:40:b0:89:80:89:ac:b0:85:88:85:42:b0:89:80:89:"
               "ac:b0:95:40:b4:91:b0:b8:89:05",
    },
    "chessboard_tl": {
        "image": """
1.1.............................................................................................................................
.1..............................................................................................................................
1.1.............................................................................................................................
.1..............................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
""",
        "seq": "81:80:81:f0:80:81:80:81:ec:81:80:81:3f:3c",
    },
    "chessboard_bl": {
        "image": """
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
.1..............................................................................................................................
1.1.............................................................................................................................
.1..............................................................................................................................
1.1.............................................................................................................................
""",
        "seq": "f0:81:80:81:ec:81:80:81:80:f0:81:80:81:3f:3c",
        "alt_seq": "f0:81:80:82:ec:81:80:81:80:f0:81:80:82:3f:3c",
    },
    "chessboard_tr": {
        "image": """
.............................................................................................................................1.1
..............................................................................................................................1.
.............................................................................................................................1.1
..............................................................................................................................1.
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
""",
        "seq": "3f:3c:81:80:81:f0:80:81:80:81:ec:81:80:81:f0",
    },
    "chessboard_br": {
        "image": """
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
..............................................................................................................................1.
.............................................................................................................................1.1
..............................................................................................................................1.
.............................................................................................................................1.1
""",
        "seq": "3f:3c:f0:81:80:81:ec:81:80:81:80:f0:81:80:81",
        "alt_seq": "3f:3c:f0:81:80:82:ec:81:80:81:80:f0:81:80:82",
    },
    "chessboard2_tl": {
        "image": """
1.1.............................................................................................................................
111.............................................................................................................................
111.............................................................................................................................
111.............................................................................................................................
111.............................................................................................................................
111.............................................................................................................................
111.............................................................................................................................
111.............................................................................................................................
111.............................................................................................................................
111.............................................................................................................................
111.............................................................................................................................
111.............................................................................................................................
111.............................................................................................................................
111.............................................................................................................................
111.............................................................................................................................
111.............................................................................................................................
111.............................................................................................................................
111.............................................................................................................................
.1..............................................................................................................................
1.1.............................................................................................................................
.1..............................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
""",
        "seq": "c5:80:81:ac:80:c5:80:81:a8:c5:80:81:3f:3c",
    },
    "chessboard2_bl": {
        "image": """
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
.1..............................................................................................................................
1.1.............................................................................................................................
.1..............................................................................................................................
111.............................................................................................................................
111.............................................................................................................................
111.............................................................................................................................
111.............................................................................................................................
111.............................................................................................................................
111.............................................................................................................................
111.............................................................................................................................
111.............................................................................................................................
111.............................................................................................................................
111.............................................................................................................................
111.............................................................................................................................
111.............................................................................................................................
111.............................................................................................................................
111.............................................................................................................................
111.............................................................................................................................
111.............................................................................................................................
111.............................................................................................................................
1.1.............................................................................................................................
""",
        "seq": "ac:81:80:c5:a8:81:80:c5:80:ac:81:80:c5:3f:3c",
        "alt_seq": "ac:81:80:c6:a8:81:80:c5:80:ac:81:80:c6:3f:3c",
    },
    "chessboard2_tr": {
        "image": """
.............................................................................................................................1.1
.............................................................................................................................111
.............................................................................................................................111
.............................................................................................................................111
.............................................................................................................................111
.............................................................................................................................111
.............................................................................................................................111
.............................................................................................................................111
.............................................................................................................................111
.............................................................................................................................111
.............................................................................................................................111
.............................................................................................................................111
.............................................................................................................................111
.............................................................................................................................111
.............................................................................................................................111
.............................................................................................................................111
.............................................................................................................................111
.............................................................................................................................111
..............................................................................................................................1.
.............................................................................................................................1.1
..............................................................................................................................1.
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
""",
        "seq": "3f:3c:c5:80:81:ac:80:c5:80:81:a8:c5:80:81:ac",
    },
    "chessboard2_br": {
        "image": """
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
................................................................................................................................
..............................................................................................................................1.
.............................................................................................................................1.1
..............................................................................................................................1.
.............................................................................................................................111
.............................................................................................................................111
.............................................................................................................................111
.............................................................................................................................111
.............................................................................................................................111
.............................................................................................................................111
.............................................................................................................................111
.............................................................................................................................111
.............................................................................................................................111
.............................................................................................................................111
.............................................................................................................................111
.............................................................................................................................111
.............................................................................................................................111
.............................................................................................................................111
.............................................................................................................................111
.............................................................................................................................111
.............................................................................................................................111
.............................................................................................................................1.1
""",
        "seq": "3f:3c:ac:81:80:c5:a8:81:80:c5:80:ac:81:80:c5",
        "alt_seq": "3f:3c:ac:81:80:c6:a8:81:80:c5:80:ac:81:80:c6",
    },
}
